#
# step1.rb

require "narray"
require "numru/advanceddcl"

include NumRu::AdvancedDCL
include NMath

nmax = 201
imax = 5
len_2 = 5

x  = 0
y0 = 1
y1 = 2
y2 = 3
y3 = 4

z1 = NArray.sfloat(nmax, len_2)
# 2nd Dimension
#    0: x, 1: y0, 2: y1, 3:y2 4: y3    in step1.f

a = []

#-- data ----
for m in 1..imax
  tm = (2*m - 1)*PI
  a[m-1] = (-1.0)**m * 2/tm
end

for n in 1..nmax
  z1[n-1,x] = 1.0*(n-1)/(nmax-1)
  tn = 2*PI*z1[n-1,x]

  z1[n-1,y0] =
    if (tn < PI/2 || tn >= PI*3/2) then 0.0 else 1.0 end
  z1[n-1,y1] = 0.5 + a[0]*cos(tn)
  z1[n-1,y2] = 0.5
  z1[n-1,y3] = 0.5

  for k in 1..imax
    tk = 2*k - 1
    tc = a[k-1]*cos(tk*tn)

    z1[n-1,y2] = z1[n-1,y2] +
      if (k <= 3) then tc else 0 end
    z1[n-1,y3] = z1[n-1,y3] + tc
  end
end

#-- graph ----
Dev.open
Frame.new

x  = z1[true,x]
y0 = z1[true,y0]
y1 = z1[true,y1]
y2 = z1[true,y2]
y3 = z1[true,y3]

Fig.inclpoint(x, y0)
Fig.inclpoint(x, y1)
Fig.inclpoint(x, y2)
Fig.inclpoint(x, y3)

Axis.title('FREQUENCY', '/DAY', 'RESPONSE', '')
Axis.draw

Plot.draw(x, y0)

Plot.lineindex = 3
Plot.draw(x, y1, "linetype"=>2)

Plot.draw(x, y2, "linetype"=>3)

Plot.draw(x, y3, "linetype"=>4)

Dev.close

