#
# kihon7.rb

require "narray"
require "numru/advanceddcl"

include NumRu::AdvancedDCL
include NMath

def aplot
  nmax = 40
  x = NArray.sfloat(nmax+1)
  y = NArray.sfloat(nmax+1)

  #-- circle ----
  dt = 2.0*PI/nmax
  for n in 0..nmax
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  Plot.draw(x, y)

  #-- triangle ----
  dt = 2.0*PI/3
  for n in 0..3
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  Plot.draw(x, y)

  #-- string ----
  Text.draw(0.0, 0.0, 'SGTXU')
  Frame.pvpr(1)

end

#-- graph ----
Dev.open

#-- frame 1 ----
Frame.new
#        XMIN,  XMAX,   YMIN,  YMAX
Fig.window=[-100.0, 100.0, -100.0, 100.0]
Fig.viewport=[ 0.0,   1.0,    0.0,   1.0]
Fig.transnum=1

aplot

#-- frame 2 ----
Frame.new

#-- upper left ----
#        XMIN,  XMAX,   YMIN,  YMAX
Fig.viewport=[ 0.1,   0.4,    0.6,   0.9]

aplot

#-- upper right ----
#        XMIN,  XMAX,   YMIN,  YMAX
Fig.window=[-100.0, 100.0,  -40.0,  40.0]
Fig.viewport=[ 0.6,   0.9,    0.6,   0.9]

aplot

#-- lower left ----
#        XMIN,  XMAX,   YMIN,  YMAX
Fig.window=[-100.0, 100.0, -200.0,   0.0]
Fig.viewport=[   0.1,   0.4,    0.1,   0.4]

aplot
      
#-- lower right ----
#        XMIN,  XMAX,   YMIN,   YMAX
Fig.window=[-100.0, 100.0,    0.0, -200.0]
Fig.viewport=[   0.6,   0.9,    0.1,   0.4]

aplot

Dev.close

