#
# map3d3.rb

require "narray"
require "numru/advanceddcl"
include NumRu::AdvancedDCL
include NMath

nx = 16
ny = 16
xmin = 120
xmax = 150
ymin = 20
ymax = 50
fact = 0.21
u = NArray.sfloat(nx, ny)
v = NArray.sfloat(nx, ny)
alon = NArray.sfloat(nx)
alat = NArray.sfloat(ny)

#-- data ---
for i in 0..nx-1
  alon[i] = xmin + (xmax-xmin)*i/(nx-1).to_f
end
for j in 0..ny-1
  alat[j] = ymin + (ymax-ymin)*j/(ny-1).to_f
end

for j in 0..ny-1
  for i in 0..nx-1
    u[i,j] =   (j-(ny-1)/2.0) * fact
    v[i,j] = - (i-(nx-1)/2.0) * fact
  end
end

#-- graph ---
Dev.open

Frame.new
Fig.lclip = true

Fig.window = [xmin, xmax, ymin, ymax]
Fig.viewport = [0.1, 0.9, 0.1, 0.9]
Fig.transnum = 10

Map.dgridmj = 10.0
Map.dgridmn = 2.0
Map.open('coast_world')
Map.draw

Arrow.arrowindex = 3
for j in 0..ny-1
  for i in 0..nx-1
    Arrow.draw(alon[i], alat[j], alon[i]+u[i,j], alat[j]+v[i,j])
  end
end

Frame.pvpr(3)
Dev.close

