#
# map3d4.rb
#   $Id: map3d4.rb,v 1.1 2000/11/18 19:03:39 keiko Exp $
#


require "narray"
require "numru/advanceddcl"
include NumRu::AdvancedDCL
include NMath


xmin = -50
xmax = 50
ymin = -50
ymax = 50
vxmin = 0.0
vxmax = 0.8
vymin = 0.0
vymax = 0.8
zmin = -50
zmax = 50
vzmin = 0.0
vzmax = 0.8
xvp3 = 2.5
yvp3 = -1.0
zvp3 = 1.5
xfc3 = (vxmax-vxmin)/2
yfc3 = (vymax-vymin)/2
zfc3 = (vzmax-vzmin)/2


def aplot(ijk)
  nmax = 40

  x = NArray.sfloat(nmax+1)
  y = NArray.sfloat(nmax+1)

  dt = 2.0*PI / nmax
  for n in 0..nmax
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  Plot.draw(x, y)
  dt = 2.0*PI / 3
  for n in 0..3
    x[n] = 40.0*sin(n*dt)
    y[n] = 40.0*cos(n*dt)
  end

  Plot.draw(x, y)

  Text.charsize = 0.07
  Text.draw(0.0, 0.0, 'DENNOU')
  cttl= format("%2.2d",ijk)
  Text.draw(0.0, -30.0, cttl)

  Frame.pvpr(1)
end

#-- graph ---
Dev.open

Text.ifont = 2

Frame.new

#-- X-Y PLANE ----
Fig.window = [xmin, xmax, ymin, ymax]
Fig.viewport = [vxmin, vxmax, vymin, vymax]
Fig.transnum = 1

Fig.plane = [1, 2, vzmax]
Fig.eyepoint = [xvp3, yvp3, zvp3]
Fig.objpoint = [xfc3, yfc3, zfc3]

aplot(1)

#-- X-Z PLANE ----
Fig.window = [xmin, xmax, zmin, zmax]
Fig.viewport = [vxmin, vxmax, vzmin, vzmax]

Fig.plane = [1, 3, vymin]

aplot(2)

#-- Y-Z PLANE ----
Fig.window = [ymin, ymax, zmin, zmax]
Fig.viewport = [vymin, vymax, vzmin, vzmax]

Fig.plane = [2, 3, vxmax]

aplot(3)

Dev.close
