#
# miss1.rb

require "narray"
require "numru/advanceddcl"

include NumRu::AdvancedDCL
include NMath


nmax = 40
xmin = 0.0
xmax = 4*PI
ymin = -1.0
ymax = 1.0

x = NArray.sfloat(nmax+1)
y = NArray.sfloat(nmax+1)

#-- data ----
dt = xmax/nmax
x = x.indgen * dt
y = sin(x)

n1 = nmax/4
rmiss = Common.rmiss
y[n1-1] = rmiss
y[n1]   = rmiss
y[n1+1] = rmiss

n2 = n1*3
y[n2-1] = rmiss
y[n2+1] = rmiss

#-- graph ----
Dev.open
Frame.new

#-- default ----
Fig.window=[xmin, xmax, ymin, ymax]
Fig.viewport=[ 0.1,  0.9,  0.7,  0.9 ]
Fig.transnum = 1

Plot.draw(x, y)

Fig.viewport=[ 0.1,  0.9,  0.5,  0.7 ]

Mark.marktype = 3
Mark.draw(x, y)

#-- cover loss data ----
Common.lmiss = true

Fig.viewport=[ 0.1,  0.9,  0.3,  0.5]

Plot.draw(x, y)

Fig.viewport=[ 0.1,  0.9,  0.1,  0.3 ]

Mark.draw(x, y)

Dev.close

